import Vue from "vue";
import Router from "vue-router";

import NotFoundComponent from "./views/NotFoundComponent.vue";
import OnlineExamHome from "./features/OnlineExam/OnlineExamHome.vue";
import OnlineExamOverview from "./features/OnlineExam/OnlineExamOverview.vue";
import ExamingHome from "./features/OnlineExam/Examing/ExamingHome.vue";
import ExamingEnd from "./features/OnlineExam/Examing/ExamingEnd.vue";
import OfflineExamHome from "./features/OfflineExam/OfflineExamHome.vue";
import OnlinePracticeHome from "./features/OnlinePractice/OnlinePracticeHome.vue";
import Login from "./features/Login/Login.vue";
import Password from "./features/Password/Password.vue";

Vue.use(Router);
let router = new Router({
  mode: "history",
  base: "/oe",
  routes: [
    {
      path: "/",
      name: "Home",
      component: OnlineExamHome
    },
    {
      path: "/login/:domain",
      name: "Login",
      component: Login
    },
    {
      path: "/online-exam",
      name: "OnlineExamHome",
      component: OnlineExamHome
    },
    {
      path: "/online-exam/exam/:examId/overview",
      name: "OnlineExamOverview",
      component: OnlineExamOverview
    },
    {
      path:
        "/online-exam/exam/:examId/examRecordData/:examRecordDataId/order/:order",
      name: "OnlineExamingHome",
      component: ExamingHome
    },
    {
      path: "/online-exam/exam/:examId/examRecordData/:examRecordDataId/end",
      name: "ExamingEnd",
      component: ExamingEnd
    },
    {
      path: "/online-practice",
      name: "OnlinePracticeHome",
      component: OnlinePracticeHome
    },
    {
      path: "/offline-exam",
      name: "OfflineExamHome",
      component: OfflineExamHome
    },
    {
      path: "/password",
      name: "Password",
      component: Password
    },
    {
      path: "*",
      component: NotFoundComponent
    }
  ]
});

router.beforeEach((to, from, next) => {
  const loginPath = "/login/" + localStorage.getItem("domain");
  if (to.path.match(/^\/login\/.+$/)) {
    next();
  } else {
    if (!window.localStorage.getItem("token")) {
      if (!localStorage.getItem("domain")) {
        alert("地址出错，找不到机构！");
      }
      next({ path: loginPath });
    } else {
      next();
    }
  }
});

export default router;
