export default function(get, regexes) {
  // cachingGet
  const cache = new Map();

  return function cachedGet(url) {
    const key = url;

    if (regexes.some(regex => url.match(regex))) {
      if (cache.has(key)) {
        return cache.get(key);
      } else {
        const request = get(...arguments);
        cache.set(key, request);
        return request;
      }
    } else {
      const request = get(...arguments);
      return request;
    }
  };
}
